#ifndef _consumer
#define _consumer

#include <systemc.h>

SC_MODULE(consumer)
{
	public:
    sc_port<sc_fifo_in_if<char> > in;

    SC_HAS_PROCESS(consumer);

    consumer(sc_module_name name) :
      sc_module(name) {
        SC_THREAD(main);
    }

    void main() {
        char c;

        while (true) {
            if (rand() & 1) {
                in->read(c);
                cout << c;
            }

            wait(1, SC_NS);
        }
    }
};

#endif

