#ifndef _producer
#define _producer

#include <systemc.h>

SC_MODULE(producer)
{
	public:
    sc_port<sc_fifo_out_if<char> > out;

    SC_HAS_PROCESS(producer);

    producer(sc_module_name name) :
      sc_module(name) {
        SC_THREAD(main);
    }

    void main() {
        const char *str =
           "Visit www.systemc.org!\n";
        const char *p = str;

        while (true) {
            if (rand() & 1) {
                out->write(*p++);
                if (!*p) p = str;
            }

            wait(1, SC_NS);
        }
    }
};

#endif
